/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.datastructure
 * File:    PollResultContainer.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.datastructure;

import java.util.ArrayList;

public class PollResultContainer {

	private ArrayList<IfmapDataType> mNew;
	private ArrayList<IfmapDataType> mUpdate;
	private ArrayList<IfmapDataType> mDelete;
	
	public PollResultContainer(ArrayList<IfmapDataType> lNew,
			ArrayList<IfmapDataType> lUpdate, 
			ArrayList<IfmapDataType> lDelete) {
		mNew = lNew;
		mUpdate = lUpdate;
		mDelete = lDelete;
	}
	
	public ArrayList<IfmapDataType> getNew(){
		return mNew;
	}
	
	public ArrayList<IfmapDataType> getUpdate(){
		return mUpdate;
	}
	
	public ArrayList<IfmapDataType> getDelete(){
		return mDelete;
	}
	
}
