/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.util
 * File:    DateUtil.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.util;

import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * Simple util class for date transformations
 * 
 */
public class DateUtil {

	private static SimpleDateFormat mDateFormatDump = new SimpleDateFormat(
			"dd-MM-yyyy HH:mm:ss");
	private static Calendar mCalendar = Calendar.getInstance();

	public static String getFormattedDateFromTimestamp(long timestamp) {
		mCalendar.setTimeInMillis(timestamp);
		return mDateFormatDump.format(mCalendar.getTime());
	}
	
	public static String getFormattedDateFromTimestamp(String timestamp) {
		try{
			long time = Long.parseLong(timestamp);
			return getFormattedDateFromTimestamp(time);
		}
		catch (NumberFormatException e) {
			return timestamp;
		}		
	}
}
