/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.view
 * File:    PublisherPanel.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.view;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import javax.swing.BorderFactory;
import javax.swing.JButton;

import javax.swing.JColorChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.WindowConstants;
import javax.swing.SwingUtilities;
import javax.swing.colorchooser.AbstractColorChooserPanel;

import de.fhhannover.inform.ifmap.event.PublisherColorChangedReceiver;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
@SuppressWarnings("serial")
public class PublisherPanel extends javax.swing.JFrame {

	{
		//Set Look & Feel
		try {
			javax.swing.UIManager.setLookAndFeel(javax.swing.UIManager.getSystemLookAndFeelClassName());
		} catch(Exception e) {
			e.printStackTrace();
		}
	}


	private HashMap<String, Color> mPublisher;
	private BorderLayout thisLayout;
	private GridLayout panelLayout;
	private JPanel panel;
	private JLabel jLabel2;
	private JLabel jLabel1;
	private JPanel defaultPanel;
	private JButton cancelButton;
	private JButton okButton;
	private JPanel jPanel1;
	private Color DEFAULT_IDENTIFIER_COLOR = new Color(153, 153, 255);
	private Color DEFAULT_METADATA_COLOR = new Color(255, 153, 102);
	private ArrayList<PublisherColorChangedReceiver> mReceiver = 
		new ArrayList<PublisherColorChangedReceiver>();
	private PublisherPanel mPublisherPanel = this;
	
	/**
	* Auto-generated main method to display this JFrame
	*/
		
	public PublisherPanel() {
		super();
		mPublisher = new HashMap<String, Color>();
		initGUI();
	}
	
	public PublisherPanel(Color ci, Color cm) {
		super();
		DEFAULT_IDENTIFIER_COLOR = ci;
		DEFAULT_METADATA_COLOR = cm;
		initGUI();
	}
	
	public PublisherPanel(String[] publisher, Color ci, Color cm) {
		this(ci, cm);
		if(publisher != null){
			addPublisher(publisher);
		}		
	}
	
	public void registerPublisherColorChangedReceiver(PublisherColorChangedReceiver rec){
		this.mReceiver.add(rec);
	}
	
	private void initGUI() {
		try {
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			thisLayout = new BorderLayout();		
			getContentPane().setLayout(thisLayout);
			getContentPane().setBackground(new java.awt.Color(255,255,255));			
			this.setResizable(false);
			{
				panel = new JPanel();
				getContentPane().add(panel, BorderLayout.CENTER);
				panelLayout = new GridLayout(1, 1);
				panelLayout.setHgap(5);
				panelLayout.setVgap(5);
				panelLayout.setColumns(1);
				panel.setLayout(panelLayout);
				panel.setBorder(BorderFactory.createTitledBorder("Publisher"));			
			}			
			{
				jPanel1 = new JPanel();
				FlowLayout jPanel1Layout = new FlowLayout();
				jPanel1Layout.setAlignment(FlowLayout.RIGHT);
				jPanel1.setLayout(jPanel1Layout);
				getContentPane().add(jPanel1, BorderLayout.SOUTH);
				{
					okButton = new JButton();
					okButton.addActionListener(new ActionListener() {
						
						@Override
						public void actionPerformed(ActionEvent arg0) {							
							for(PublisherColorChangedReceiver rec : mReceiver){
								rec.setNewColorSelection(mPublisher, DEFAULT_IDENTIFIER_COLOR, 
										DEFAULT_METADATA_COLOR);
							}							
							mPublisherPanel.setVisible(false);
						}
					});
					jPanel1.add(okButton);
					okButton.setText("Ok");
				}
				{
					cancelButton = new JButton();
					cancelButton.addActionListener(new ActionListener() {
						
						@Override
						public void actionPerformed(ActionEvent arg0) {
							mPublisherPanel.setVisible(false);
						}
					});
					jPanel1.add(cancelButton);
					cancelButton.setText("Cancel");					
				}
			}
			{
				defaultPanel = new JPanel();
				GridLayout defaultPanelLayout = new GridLayout(2, 2);
				defaultPanelLayout.setHgap(5);
				defaultPanelLayout.setVgap(5);
				defaultPanelLayout.setColumns(1);
				defaultPanelLayout.setRows(2);
				defaultPanel.setLayout(defaultPanelLayout);
				getContentPane().add(defaultPanel, BorderLayout.NORTH);
				defaultPanel.setBorder(BorderFactory.createTitledBorder("Default"));
				JPanel pan = new JPanel();
				{
					jLabel1 = new JLabel();					
					jLabel1.setText("IdentifierData");
					pan.add(jLabel1);
				}
				{					
					final ColorButton but = new ColorButton(DEFAULT_IDENTIFIER_COLOR, 64, 32);
					but.addActionListener(new ActionListener() {
						
						@Override
						public void actionPerformed(ActionEvent arg0) {
							Color newColor = JColorChooser.showDialog(
				                     but,
				                     "Choose Color",
				                     DEFAULT_IDENTIFIER_COLOR);
							if(newColor != null){								
								but.setColor(newColor);
								DEFAULT_IDENTIFIER_COLOR = newColor;
							}
						}
					});
					pan.add(but);
				}
				defaultPanel.add(pan);
				JPanel pan2 = new JPanel();
				{
					jLabel2 = new JLabel();					
					jLabel2.setText("Metadata");
					pan2.add(jLabel2);
				}
				{					
					final ColorButton but2 = new ColorButton(DEFAULT_METADATA_COLOR, 64, 32);
					but2.addActionListener(new ActionListener() {
						
						@Override
						public void actionPerformed(ActionEvent arg0) {
							Color newColor = JColorChooser.showDialog(
				                     but2,
				                     "Choose Color",
				                     DEFAULT_METADATA_COLOR);
							if(newColor != null){								
								but2.setColor(newColor);								
								DEFAULT_METADATA_COLOR = newColor;
							}
						}
					});
					pan2.add(but2);
				}
				defaultPanel.add(pan2);
			}
			
			panelLayout.setRows(0);
			this.pack();
			this.repaint();
		} catch (Exception e) {
		    //add your error handling code here
			e.printStackTrace();
		}
	}		
	
	private void addToPanel(final String publisher, final Color c){		
		JPanel p = new JPanel();
		p.add(new JLabel(publisher));
		final ColorButton but = new ColorButton(c, 64, 32);		
		but.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				Color newColor = JColorChooser.showDialog(
	                     but,
	                     "Choose Color",
	                     c);
				if(newColor != null){
					mPublisher.put(publisher, newColor);					
					but.setColor(newColor);					
				}
			}
		});
		p.add(but);

		panelLayout.setRows(panelLayout.getRows()+1);	
		panel.add(p);						
	}
	
	public void addPublisher(String[] publisher){
		for(String p : publisher){
			if(!this.mPublisher.containsKey(p)){				
				this.mPublisher.put(p, DEFAULT_METADATA_COLOR);				
				this.addToPanel(p, DEFAULT_METADATA_COLOR);
			}
		}
		this.pack();
		this.repaint();		
	}
	public static void main(String[] args) {
		PublisherPanel panel = new PublisherPanel();
		String[] publisher = new String[]{"test1234", "abcdef"};
		panel.addPublisher(publisher);
		panel.pack();
		panel.setVisible(true);
	}

}

@SuppressWarnings("serial")
class ColorButton extends JButton{
	
	private Color mColor;
	
	public ColorButton() {
		super();
	}
	
	ColorButton(Color color){
		super();
		mColor = color;
	}
	
	ColorButton(Color color, int width, int heigth){
		super();
		mColor = color;
		Dimension d = new Dimension(width, heigth);
		setSize(d);
		setPreferredSize(d);
		setFocusable(false);
	}
	
	@Override
	public void paintComponent(Graphics g) {
		super.paintComponent(g); 
		g.setColor(mColor);
		g.fillRect(10, 10, this.getWidth()-20, this.getHeight()-20);		
	}
	
	public void setColor(Color c){
		mColor = c;
		revalidate();
	}
}

