/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.view
 * File:    QuickMetaSubscribe.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.view;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.AbstractAction;
import java.awt.event.ActionEvent;
import javax.swing.Action;

public class QuickMetaSubscribe extends JPanel {
	
	private static final long serialVersionUID = -9105336717460904279L;
	private JTextField textField_1;
	private JTextField textField_2;
	private final Action subscribeAction = new SwingAction();

	/**
	 * Create the panel.
	 */
	public QuickMetaSubscribe() {
		setAlignmentY(2.0f);
		setAlignmentX(2.0f);
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0, 0, 0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		
		JLabel lblTerminals = new JLabel("terminals");
		GridBagConstraints gbc_lblTerminals = new GridBagConstraints();
		gbc_lblTerminals.anchor = GridBagConstraints.EAST;
		gbc_lblTerminals.insets = new Insets(0, 0, 5, 5);
		gbc_lblTerminals.gridx = 0;
		gbc_lblTerminals.gridy = 0;
		add(lblTerminals, gbc_lblTerminals);
		
		JCheckBox chckbxMac = new JCheckBox("mac");
		GridBagConstraints gbc_chckbxMac = new GridBagConstraints();
		gbc_chckbxMac.anchor = GridBagConstraints.WEST;
		gbc_chckbxMac.insets = new Insets(0, 0, 5, 5);
		gbc_chckbxMac.gridx = 1;
		gbc_chckbxMac.gridy = 0;
		add(chckbxMac, gbc_chckbxMac);
		
		JCheckBox chckbxDevice = new JCheckBox("dev");
		GridBagConstraints gbc_chckbxDevice = new GridBagConstraints();
		gbc_chckbxDevice.anchor = GridBagConstraints.WEST;
		gbc_chckbxDevice.insets = new Insets(0, 0, 5, 5);
		gbc_chckbxDevice.gridx = 2;
		gbc_chckbxDevice.gridy = 0;
		add(chckbxDevice, gbc_chckbxDevice);
		
		JCheckBox chckbxIp_1 = new JCheckBox("ip");
		GridBagConstraints gbc_chckbxIp_1 = new GridBagConstraints();
		gbc_chckbxIp_1.anchor = GridBagConstraints.WEST;
		gbc_chckbxIp_1.insets = new Insets(0, 0, 5, 5);
		gbc_chckbxIp_1.gridx = 3;
		gbc_chckbxIp_1.gridy = 0;
		add(chckbxIp_1, gbc_chckbxIp_1);
		
		JCheckBox chckbxId = new JCheckBox("id");
		GridBagConstraints gbc_chckbxId = new GridBagConstraints();
		gbc_chckbxId.anchor = GridBagConstraints.WEST;
		gbc_chckbxId.insets = new Insets(0, 0, 5, 5);
		gbc_chckbxId.gridx = 4;
		gbc_chckbxId.gridy = 0;
		add(chckbxId, gbc_chckbxId);
		
		JCheckBox chckbxAr = new JCheckBox("ar");
		GridBagConstraints gbc_chckbxAr = new GridBagConstraints();
		gbc_chckbxAr.anchor = GridBagConstraints.WEST;
		gbc_chckbxAr.insets = new Insets(0, 0, 5, 0);
		gbc_chckbxAr.gridx = 5;
		gbc_chckbxAr.gridy = 0;
		add(chckbxAr, gbc_chckbxAr);
		
		JLabel lblMaxdepth = new JLabel("max-depth");
		GridBagConstraints gbc_lblMaxdepth = new GridBagConstraints();
		gbc_lblMaxdepth.anchor = GridBagConstraints.EAST;
		gbc_lblMaxdepth.insets = new Insets(0, 0, 5, 5);
		gbc_lblMaxdepth.gridx = 0;
		gbc_lblMaxdepth.gridy = 1;
		add(lblMaxdepth, gbc_lblMaxdepth);
		
		JSpinner spinner = new JSpinner();
		spinner.setModel(new SpinnerNumberModel(new Integer(8), null, null, new Integer(1)));
		GridBagConstraints gbc_spinner = new GridBagConstraints();
		gbc_spinner.fill = GridBagConstraints.HORIZONTAL;
		gbc_spinner.insets = new Insets(0, 0, 5, 5);
		gbc_spinner.gridx = 1;
		gbc_spinner.gridy = 1;
		add(spinner, gbc_spinner);
		
		JLabel lblMaxsize = new JLabel("max-size");
		GridBagConstraints gbc_lblMaxsize = new GridBagConstraints();
		gbc_lblMaxsize.anchor = GridBagConstraints.EAST;
		gbc_lblMaxsize.insets = new Insets(0, 0, 5, 5);
		gbc_lblMaxsize.gridx = 2;
		gbc_lblMaxsize.gridy = 1;
		add(lblMaxsize, gbc_lblMaxsize);
		
		JSpinner spinner_1 = new JSpinner();
		spinner_1.setModel(new SpinnerNumberModel(new Integer(64384), null, null, new Integer(1)));
		GridBagConstraints gbc_spinner_1 = new GridBagConstraints();
		gbc_spinner_1.fill = GridBagConstraints.HORIZONTAL;
		gbc_spinner_1.gridwidth = 2;
		gbc_spinner_1.insets = new Insets(0, 0, 5, 5);
		gbc_spinner_1.gridx = 3;
		gbc_spinner_1.gridy = 1;
		add(spinner_1, gbc_spinner_1);
		
		JLabel lblResultfilter = new JLabel("result-filter");
		GridBagConstraints gbc_lblResultfilter = new GridBagConstraints();
		gbc_lblResultfilter.anchor = GridBagConstraints.EAST;
		gbc_lblResultfilter.insets = new Insets(0, 0, 5, 5);
		gbc_lblResultfilter.gridx = 0;
		gbc_lblResultfilter.gridy = 2;
		add(lblResultfilter, gbc_lblResultfilter);
		
		textField_1 = new JTextField();
		GridBagConstraints gbc_textField_1 = new GridBagConstraints();
		gbc_textField_1.gridwidth = 5;
		gbc_textField_1.insets = new Insets(0, 0, 5, 0);
		gbc_textField_1.fill = GridBagConstraints.HORIZONTAL;
		gbc_textField_1.gridx = 1;
		gbc_textField_1.gridy = 2;
		add(textField_1, gbc_textField_1);
		textField_1.setColumns(10);
		
		JLabel lblMatchlinks = new JLabel("match-links");
		GridBagConstraints gbc_lblMatchlinks = new GridBagConstraints();
		gbc_lblMatchlinks.anchor = GridBagConstraints.EAST;
		gbc_lblMatchlinks.insets = new Insets(0, 0, 5, 5);
		gbc_lblMatchlinks.gridx = 0;
		gbc_lblMatchlinks.gridy = 3;
		add(lblMatchlinks, gbc_lblMatchlinks);
		
		textField_2 = new JTextField();
		GridBagConstraints gbc_textField_2 = new GridBagConstraints();
		gbc_textField_2.gridwidth = 5;
		gbc_textField_2.insets = new Insets(0, 0, 5, 0);
		gbc_textField_2.fill = GridBagConstraints.HORIZONTAL;
		gbc_textField_2.gridx = 1;
		gbc_textField_2.gridy = 3;
		add(textField_2, gbc_textField_2);
		textField_2.setColumns(10);
		
		JButton btnSubscribe = new JButton("Subscribe");
		btnSubscribe.setAction(subscribeAction);
		GridBagConstraints gbc_btnSubscribe = new GridBagConstraints();
		gbc_btnSubscribe.gridwidth = 4;
		gbc_btnSubscribe.anchor = GridBagConstraints.EAST;
		gbc_btnSubscribe.gridx = 2;
		gbc_btnSubscribe.gridy = 4;
		add(btnSubscribe, gbc_btnSubscribe);

	}

	private class SwingAction extends AbstractAction {
		public SwingAction() {
			putValue(NAME, "SwingAction");
			putValue(SHORT_DESCRIPTION, "Triggers a subscription");
		}
		public void actionPerformed(ActionEvent e) {
			Component comp = ((Component)e.getSource()).getParent().getComponent(0);
			
		}
	}
}
