/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.view
 * File:    QuickSubscribeIdentity.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.view;

import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JComboBox;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JButton;

public class QuickSubscribeIdentity extends JPanel {
	public JTextField textField;
	public JTextField textField_1;

	/**
	 * Create the panel.
	 */
	public QuickSubscribeIdentity() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{15, 0, 155, 0, 0};
		gridBagLayout.rowHeights = new int[]{5, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 1.0, 1.0, 0.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		
		QuickComboBox comboBox = new QuickComboBox();
		ComboBoxModel jComboBox1Model = 
			new DefaultComboBoxModel(
					new String[] { "aik-name", "distinguished-name", "dns-name",
							"email-address", "kerberos-principal", "username",
							"sip-uri", "tel-uri", "hip-tip", "other" });						
		jComboBox1Model.setSelectedItem("aik-name");
		comboBox.setModel(jComboBox1Model);
		
		GridBagConstraints gbc_comboBox = new GridBagConstraints();
		gbc_comboBox.insets = new Insets(0, 0, 5, 5);
		gbc_comboBox.anchor = GridBagConstraints.WEST;
		gbc_comboBox.gridx = 1;
		gbc_comboBox.gridy = 1;
		add(comboBox, gbc_comboBox);
		
		textField = new JTextField();
		GridBagConstraints gbc_textField = new GridBagConstraints();
		gbc_textField.insets = new Insets(0, 0, 5, 5);
		gbc_textField.fill = GridBagConstraints.HORIZONTAL;
		gbc_textField.gridx = 2;
		gbc_textField.gridy = 1;
		add(textField, gbc_textField);
		textField.setColumns(10);
		
		JLabel lblAdministrativedomain = new JLabel("administrative-domain");
		GridBagConstraints gbc_lblAdministrativedomain = new GridBagConstraints();
		gbc_lblAdministrativedomain.anchor = GridBagConstraints.EAST;
		gbc_lblAdministrativedomain.insets = new Insets(0, 0, 5, 5);
		gbc_lblAdministrativedomain.gridx = 1;
		gbc_lblAdministrativedomain.gridy = 2;
		add(lblAdministrativedomain, gbc_lblAdministrativedomain);
		
		textField_1 = new JTextField();
		GridBagConstraints gbc_textField_1 = new GridBagConstraints();
		gbc_textField_1.insets = new Insets(0, 0, 5, 5);
		gbc_textField_1.fill = GridBagConstraints.HORIZONTAL;
		gbc_textField_1.gridx = 2;
		gbc_textField_1.gridy = 2;
		add(textField_1, gbc_textField_1);
		textField_1.setColumns(10);
		
		JButton btnSubscribe = new JButton("Subscribe");
		GridBagConstraints gbc_btnSubscribe = new GridBagConstraints();
		gbc_btnSubscribe.anchor = GridBagConstraints.EAST;
		gbc_btnSubscribe.insets = new Insets(0, 0, 5, 5);
		gbc_btnSubscribe.gridx = 2;
		gbc_btnSubscribe.gridy = 3;
		add(btnSubscribe, gbc_btnSubscribe);

	}

}
