/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.view
 * File:    QuickSubscribeIp.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.view;

import javax.swing.JPanel;
import javax.swing.border.TitledBorder;
import javax.swing.UIManager;
import java.awt.Color;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import javax.swing.JTextField;
import java.awt.Insets;
import javax.swing.JRadioButton;
import javax.swing.JCheckBox;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JButton;
import javax.swing.ButtonGroup;
import javax.swing.border.LineBorder;
import java.awt.BorderLayout;
import javax.swing.BoxLayout;
import java.awt.GridLayout;
import javax.swing.border.MatteBorder;
import java.awt.SystemColor;

public class QuickSubscribeIp extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -9105336717460904279L;
	public JTextField textField;
	public final ButtonGroup type = new ButtonGroup();

	/**
	 * Create the panel.
	 */
	public QuickSubscribeIp() {
		setBorder(new MatteBorder(1, 1, 1, 1, (Color) null));
		setAlignmentY(2.0f);
		setAlignmentX(2.0f);
		setLayout(new BorderLayout(5, 5));
		
		JPanel panel = new JPanel();
		add(panel, BorderLayout.NORTH);
		GridBagLayout gbl_panel = new GridBagLayout();
		gbl_panel.columnWidths = new int[]{69, 69, 69, 0};
		gbl_panel.rowHeights = new int[]{25, 0, 0};
		gbl_panel.columnWeights = new double[]{0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_panel.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
		panel.setLayout(gbl_panel);
		
		JLabel lblIpaddress = new JLabel("value");
		GridBagConstraints gbc_lblIpaddress = new GridBagConstraints();
		gbc_lblIpaddress.anchor = GridBagConstraints.EAST;
		gbc_lblIpaddress.fill = GridBagConstraints.VERTICAL;
		gbc_lblIpaddress.insets = new Insets(0, 0, 5, 5);
		gbc_lblIpaddress.gridx = 0;
		gbc_lblIpaddress.gridy = 0;
		panel.add(lblIpaddress, gbc_lblIpaddress);
		
		textField = new JTextField();
		GridBagConstraints gbc_textField = new GridBagConstraints();
		gbc_textField.gridwidth = 2;
		gbc_textField.fill = GridBagConstraints.BOTH;
		gbc_textField.insets = new Insets(0, 0, 5, 0);
		gbc_textField.gridx = 1;
		gbc_textField.gridy = 0;
		panel.add(textField, gbc_textField);
		textField.setColumns(10);
		
		JLabel lblIptype = new JLabel("type");
		GridBagConstraints gbc_lblIptype = new GridBagConstraints();
		gbc_lblIptype.anchor = GridBagConstraints.EAST;
		gbc_lblIptype.fill = GridBagConstraints.VERTICAL;
		gbc_lblIptype.insets = new Insets(0, 0, 0, 5);
		gbc_lblIptype.gridx = 0;
		gbc_lblIptype.gridy = 1;
		panel.add(lblIptype, gbc_lblIptype);
		
		JRadioButton rdbtnIpv = new JRadioButton("IPv4");
		GridBagConstraints gbc_rdbtnIpv = new GridBagConstraints();
		gbc_rdbtnIpv.fill = GridBagConstraints.BOTH;
		gbc_rdbtnIpv.insets = new Insets(0, 0, 0, 5);
		gbc_rdbtnIpv.gridx = 1;
		gbc_rdbtnIpv.gridy = 1;
		panel.add(rdbtnIpv, gbc_rdbtnIpv);
		type.add(rdbtnIpv);
		rdbtnIpv.setSelected(true);
		
		JRadioButton rdbtnIpv_1 = new JRadioButton("IPv6");
		GridBagConstraints gbc_rdbtnIpv_1 = new GridBagConstraints();
		gbc_rdbtnIpv_1.fill = GridBagConstraints.BOTH;
		gbc_rdbtnIpv_1.gridx = 2;
		gbc_rdbtnIpv_1.gridy = 1;
		panel.add(rdbtnIpv_1, gbc_rdbtnIpv_1);
		type.add(rdbtnIpv_1);
		
		QuickMetaSubscribe quickMetaSubscribe = new QuickMetaSubscribe();
		add(quickMetaSubscribe, BorderLayout.CENTER);

	}

}
